// Ores.cs
// starting Mining Ores
$Dig_Radioactivedepth=4000;
exec("./lava.cs");

if ( !isObject(OreData) )
  {
   new SimSet(OreData)
      {
       new ScriptObject(MineDirt) { name="Dirt";            value=0;     color=54; minPercent=0;    MaxPercent=100;  depth=0;     };
       new ScriptObject(MineOre) { name="Einsteinium";      value=5;     color=4;  minPercent=87;   maxpercent=89;   depth=-15;   veinLength=8; };
       new ScriptObject(MineOre) { name="Gold";             value=30;    color=3;  minPercent=83;   maxPercent=84;   depth=0;   veinLength=10; };
       new ScriptObject(MineOre) { name="Silver";           value=15;    color=30; minPercent=84;   maxPercent=85;   depth=0;   veinLength=11; };
       new ScriptObject(MineOre) { name="Diamond";          value=100;   color=17; minPercent=85;   maxPercent=86;   depth=0;   veinLength=5;  };
       new ScriptObject(MineOre) { name="Platinum";         value=50;    color=44; minPercent=86;   maxPercent=87;   depth=0;   veinLength=10; };
       new ScriptObject(MineOre) { name="Epicness";        value=1000000; color=7; minPercent=0.1;  maxPercent=0.2;  depth=5000;veinLength=2; NoBomb=1;minPick=1000; };
      };
  }

if ( !isObject(DirtData) )
  {
   new SimSet(DirtData)
      {
       new ScriptObject(DirtRecord) { name="Ground";              Sdepth="6000";   Edepth="300";    health="25000"; colorStart="1";   colorSize="2"; };
       new ScriptObject(DirtRecord) { name="Sand";                Sdepth="300";   Edepth="150";    health="25";    colorStart="43";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Loose Dirt";          Sdepth="150";   Edepth="25";     health="10";    colorStart="44";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Dirt";                Sdepth="25";    Edepth="-150";   health="10";    colorStart="54";  colorSize="4"; };
       new ScriptObject(DirtRecord) { name="Dense Dirt";          Sdepth="-150";  Edepth="-300";   health="50";    colorStart="57";  colorSize="4"; };
       new ScriptObject(DirtRecord) { name="Rock";                Sdepth="-300";  Edepth="-600";   health="100";   colorStart="46";  colorSize="3"; };
       new ScriptObject(DirtRecord) { name="Hard Rock";           Sdepth="-600";  Edepth="-900";   health="200";   colorStart="49";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Seriously Hard Rock"; Sdepth="-900";  EDepth="-1200";  health="400";   colorStart="50";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Metal Rock";          Sdepth="-1200"; EDepth="-1800";  health="800";   colorStart="51";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Hard Metal Rock";     Sdepth="-1800"; EDepth="-2400";  health="1600";  colorStart="51";  colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Seriously Hard Metal Rock"; Sdepth="-2400"; Edepth="-5000"; health="3200"; colorStart="51"; colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Core";                Sdepth="-5000"; Edepth="-8000";  health="32000"; colorStart="52"; colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Hard Core";           Sdepth="-8000"; Edepth="-16000"; health="64000"; colorStart="52"; colorSize="1"; };
       new ScriptObject(DirtRecord) { name="Seriously Hard Core"; Sdepth="-16000"; Edepth="-25000"; health="128000"; colorStart="39"; colorSize="1"; };
      };
  }

// return true if this ore should be placed
function MineOre::CheckPlace(%this, %pos, %random)
   {
    if ( %this.disabled==1)
      return;

    if ( (%random <= %this.maxPercent) && (%random >= %this.minPercent) )
      {
       if ( %this.depth == 0)
         {
          return true;
         }
       %z = getWord(%pos, 2);
       if ( %this.depth < 0)
         {
          if ( %z <= %this.depth)
            {
             return true;
            }
         }
       else
         if ( %z >= %this.depth)
           {
            return true;
           }
      }
    return false;
   }


// place ore at %position
function MineOre::placeAt(%this, %pos, %random)
   {
    %health=%this.value * 4;
    %brick = PlaceBrick(%pos, %health, %this.color, %this.colorFx, %this.ShapeFx, %this);
    CheckRadioActive(%brick, %pos);

    // create an ore vein
    %rnd = getRandom(1,6);
    switch ( %rnd)
		  {
       case 1 :
         %dir = "1 0 0";
       case 2 :
         %dir = "-1 0 0";
       case 3 :
         %dir = "0 1 0";
       case 4 :
         %dir = "0 -1 0";
       case 5 :
         %dir = "0 0 1";
       case 6 :
         %dir = "0 0 -1";
		  }
    %length = getRandom(1, %this.veinLength);
    %currPos = %pos;
    for (%a=0; %a<= %length; %a++)
      {
       %currPos = VectorAdd(%currPos, %dir);
       if ( !$Dig_PlacedDirt[%currPos] )
         {
          $Dig_placedDirt[%currPos] = %this.getName() TAB %this SPC %brick.radioactive SPC %brick.multiplier;
         }
      }
    return %brick;
   }

// check to see if %brick can be made radioactive
function CheckRadioActive(%brick, %pos)
   {
    if ( getrandom(1,2) == 2)
      {
       %depth = %brick.type.depth;
       if ( %depth == 0)
         {
          %depth = 0 - $Dig_Radioactivedepth;
         }
       else
         %depth = %brick.type.depth - $Dig_Radioactivedepth;

       if ( getWord(%pos, 2) < %depth )
			   {
					%brick.multiplier=getRandom(1,20);
			    %brick.health*=%brick.multiplier*2;
			    %brick.radioactive=true;
  			 }
		  }
   }

// based on whats in %dirtRecord - make a new ore block
function MineOre::placeContinue(%blank, %dirtRecord, %pos)
   {
		%data   = getField(%dirtRecord, 1);
		%this   = getWord(%data, 0);
		%brick  = PlaceBrick(%pos, %this.value * 4, %this.color, %this.colorFx, %this.ShapeFx, %this);

		%brick.radioactive=getword(%data, 1);
		%brick.multiplier=getWord(%data,2);
		if ( %brick.radioactive)
		  {
			 %brick.health=%this.value * 4 * %brick.multiplier;
		  }
		return %brick;
   }

// place a dirt block at %pos
function MineDirt::PlaceAt(%this, %pos, %random)
   {
    //if ( $Dig_Lava.checkPlace(%pos, %random) )
    //  {
    //   return $Dig_Lava.placeAt(%pos);
    //  }
		%z= getword(%pos, 2);
		for ( %a=0; %a < DirtData.getCount(); %a++)
		  {
			 %dirt = DirtData.getObject(%a);
			 if ( %z <= %dirt.SDepth && %z >= %dirt.EDepth)
			   {
					%color = %dirt.colorStart;
          if ( %dirt.colorSize > 1)
            {
             // adjust color depending on how far we are into the current layer of dirt
             %diff = %dirt.Sdepth - %dirt.Edepth;
             %change = mabs(mFloor( ( (%z - %dirt.Sdepth) / %diff)* %dirt.colorSize));
						 %change--;
             if ( %change > %dirt.colorSize)
               {
                %change=%dirt.colorSize;
               }
             %color += %change;
            }

	        %brick = Placebrick(%pos, %dirt.health, %color, 0, 0, %this );
	        %brick.DirtType=%dirt;
					CheckRadioActive(%brick, %pos);
	        return %brick;
			   }
		  }
    %dirt = DirtData.getObject(0);
    %brick = Placebrick(%pos, %dirt.health, %color, 0, 0, %this );
    %brick.DirtType=%dirt;
    CheckRadioActive(%brick, %pos);
    return %brick;
   }

// return ore name to display for the client
function MineDirt::getMineName(%this, %brick)
   {
		if ( %brick.radioactive )
		  {
			 return "<color:FFFF00>Radioactive <color:FFFFFF>" @ %brick.dirtType.name;
		  }
		else
		  return "<color:FFFFFF>" @ %brick.dirtType.name;
   }
function MineOre::getMineName(%this, %brick)
   {
		if ( %brick.radioactive )
		  {
			 return "<color:FFFF00>Radioactive <color:11FFAA>" @ %this.name;
		  }
		else
		  return "<color:11FFAA>" @ %this.name;
   }

// Mine dirt block
function MineDirt::mined(%this, %client, %brick, %mode)
   {
		%health=$modeHealth[%mode];
		if ( %health > 0)
		  {
       if (%client.pickaxeNum)
         %brick.health -= 1*%client.pickaxeNum;
       else
         %brick.health--;
			 }
		%brick.health*= %health;

		// if the brick is dead and we are checking for discoveries... do so
    if (%brick.health < 1)
      {
       if ( %mode $= "drill" || %mode $= "bomb" )
         return;

       if ( %brick.radioactive)
         %client.AddDirt( mFloor(%brick.multiplier * $modeMoney[%mode]) );
       else
         %client.AddDirt(1);

		 	 if ( $ModeDiscover[%mode] ==1)
		 	   {
          Dig_CheckDiscoverOre(%client);
   	 		 }
      }
   }

// Mine an ore - this one gives $$
function MineOre::mined(%this, %client, %brick, %mode)
   {
		%health=$modeHealth[%mode];
		%money =$modeMoney[%mode];
		if ( %health > 0)
		  {
       if ( %brick.radioactive)
         {
          %minPick = %this.minPick * mFloor(%brick.multiplier / 2);
         }
       else
         %minPick = %this.minPick;

       if ( %minPick > %client.pickaxenum)
         {
          MessageClient(%client, '', "<color:FF0000>you need a pick of " @ %minPick @ " to mine that");
          return;
         }
       if (%client.pickaxeNum)
         %brick.health -= 1*%client.pickaxeNum;
       else
         %brick.health--;
      }
		%brick.health*= %health;

		// if the brick is dead, update the client's money
    if (%brick.health < 1)
      {
       // some ores give no money when bombed
       if ( %this.NoBomb && %mode $= "bomb")
         {
          return;
         }
			 if ( %brick.radioactive)
			   {
					MineRadioactive(%this, %client, %brick, %mode);
			   }
			 else
				 {
          if ( isObject(%client))
            %client.AddOreLog(%this, mFloor(%this.value * %money), false );
         }
			}
   }

// client minded some radioactive ore
function MineRadioactive(%this, %client, %brick, %mode)
   {
		%health=$modeHealth[%mode];
		%money =$modeMoney[%mode];
    if ( isObject(%client))
      %client.AddOreLog(%this, mFloor(%this.value * %brick.multiplier * %money), true);

		%damage = 0;
    if ( %mode !$= "bomb")
			%damage = %brick.multiplier * %money;

    if ( %health > 0)
      {
       %msg = "You have been irradiated";

       // burn rad suit as needed
       if ( %client.radsuit > 0)
         {
          %client.radsuit-= %damage;
          if ( %client.radsuit < 0)
            {
             %damage-=mabs(%client.radsuit);
             %client.radsuit=0;
             %msg = "<color:5555FF>Your radsuit was destroyed by the radioactive ore -- you need to buy a new one";
            }
          else
            {
            %msg = "<color:5555FF>Your radsuit absorbed <color:0000FF>" @ %damage @ " Rads.<color:5555FF>You have " @ %client.radsuit @ " Left";
            %damage=0;
           }
         }
       %client.player.radDamage+=%damage;
       %hp = 100;
		   %rPercent = %client.player.radDamage / %hp;
		   if ( %client.player.radDamage >= %hp)
		     {
					switch ( getRandom(1,3) )
					  {
						 case 1:
						   messageAll('', "<color:0000FF>" @ %client.getplayerName() @ " <color:00FF00>Died of radiation poisoning");
		   	       %client.player.kill();
		   	       %client.player.radDamage=0;
               %client.radsuit=0;
		   	       return;
						 case 2 :
               %msg = "You Have been mutated";
               %x=getRandom() + 0.5;
               %y=getRandom() + 0.5;
               %z=getRandom() + 0.5;
               %client.player.setScale(%x SPC %y SPC %z);
               %client.player.radDamage=0;
               AddLog(%client, "mutate", "scale: " @ %x SPC %y SPC %z);
						 case 3 :
               %msg = "You Escaped dieing from radiation poisoning            for now";
					  }
		     }
			 else
				 {
		      if ( %rPercent > 0.25)
		        {
             %msg = "You are getting radation poisoning";
		        }
		      if ( %rPercent > 0.4)
		        {
             %msg = "You have Radation poisoning";
		        }
		      if ( %rPercent > 0.6)
		        {
             %msg = "You have Radation Sickness";
		        }
		      if ( %rPercent > 0.8 )
		        {
             %msg = "You have Severe radation sickness.<color:FFFFFF> Try /cureRad to get better";
		        }
				 }
       messageClient(%client, '', "<color:0000FF>" @ %msg);
			}
   }

// return a copy of this ore
function MineOre::copy(%this)
   {
		%new = new ScriptObject(MineOre)
	     {
				name  = %this.name;
				value = %this.value;
				color = %this.color;
				minPercent=%this.minPercent;
				maxPercent=%this.maxPercent;
				depth = %this.depth;
			 };
		return %new;
   }

// place a brick at the given spot and stats
function PlaceBrick(%pos, %health, %color, %colorFx, %shapeFX, %type)
   {
    %brick = new fxDTSBrick()
      {
       client = $Dig_host;
       datablock = "brick4xCubeData";
       position = %pos;
       rotation = "0 0 0 0";
       colorID = %color;
       scale = "1 1 1";
       angleID = 0;
       colorfxID = %colorfx;
       shapefxID = %shapeFx;
       isPlanted = 1;
       stackBL_ID = $Dig_host_id;
       type = %type;
			 health = %health;
       isMineable = 1;
      };
   %brick.plant();
   $Dig_host_brickgroup.add(%brick);
   $Dig_placedDirt[%pos] = %brick;
	 return %brick;
   }


// cure radation sickness
function serverCmdCureRad(%client)
   {
		if ( %client.player.radDamage < 1)
		  {
			 Dig_DisplayError(%client, "You dont have any radation damage");
			 return;
		  }
		messageClient(%client, '', "<color:FFFF00>You have " @ %client.player.RadDamage @ " Radiation Damage");
		messageClient(%client, '', "<color:FFFF00>It will cost " @ %client.player.RadDamage @ " pick levels -OR- $" @ %client.player.RadDamage*500 @ " To cure");
		messageClient(%client, '', "<color:FFFF00>say: /curepick or /curemoney to cure yourself");
   }

// cure radiation sickness by paying with pick levels
function serverCmdCurePick(%client)
  {
   if ( %client.player.radDamage < 1)
     {
      Dig_DisplayError(%client, "You dont have any radation damage");
      return;
     }
   if ( %client.pickaxeNum < %client.player.RadDamage)
     {
      Dig_Displayerror(%client, "You dont have enough pick levels to pay for treatment");
      return;
     }

   messageClient(%client, '', "<color:FFFF00>You spent " @ %client.player.RadDamage @ " Pick levels to cure yourself");
   client.pickaxenum-=%client.player.RadDamage;
   client.player.RadDamage=0;
   %client.sendMiningStatus();
  }

// cure radation sickness by paying with money
function serverCmdCureMoney(%client)
  {
   if ( %client.player.radDamage < 1)
     {
      Dig_DisplayError(%client, "You dont have any radation damage");
      return;
     }
   messageClient(%client, '', "<color:FFFF00>You spent $" @ %client.player.RadDamage*500 @ " to cure yourself");
   %client.AddMoney( -(%client.player.RadDamage * 500) );
   %client.player.RadDamage=0;
   %client.sendMiningStatus();
  }

// create a randomly located 'blob' of each ore
function makeOreBlobs()
   {
    for ( %a=1; %a < OreData.getCount(); %a++)
      {
       %ore = OreData.getObject(%a);
       %x=getRandom(-200,200) * 4;
       %y=getRandom(-200,200) * 4;
       %z=getRandom($Dig_Data_MaxDepth, $Dig_Data_MaxHeight);
       if ( %ore.depth > 0 && %z < %ore.depth )
         {
          %z=getRandom(%ore.depth, $Dig_Data_Maxheight);
         }
       if ( %ore.depth < 0 && %z > %ore.depth)
         {
          %z=getRandom(%ore.depth, $Dig_Data_MaxDepth);
         }
       %z = mFloor(%z / 2) * 2; //ensure z is an even number

       if ( %z < $Dig_Data_MaxDepth)
         {
          %z = $Dig_Data_maxDepth + 20;
         }
       if ( %z > $Dig_Data_MaxHeight)
         {
          %z = $Dig_Data_maxHeight - 20;
         }
       %x++; %y++; // move onto the mining block grid
       schedule(%a*1000, MissionGroup, "MakeOreBlob", %ore, %x SPC %y SPC %z);
      }
   }

// make an ore blob using %ore, centered at %pos
function MakeOreBlob(%ore, %pos)
   {
    echo("make ore blob: " @ %ore.name @ " at " @ %pos);
    %health=%ore.value * 4;

    %blobSize = 10;
    for ( %x= getWord(%pos, 0)-%blobSize; %x < getWord(%pos, 0)+%blobSize; %x+=2)
      {
       for ( %y=getWord(%pos, 1)-%blobSize; %y < getWord(%pos, 1)+%blobSize; %y+=2)
         {
          for ( %z=getWord(%pos,2)-%blobSize; %z <getWord(%pos, 2)+%blobSize; %z+=2)
            {
             %pos1 = %x SPC %y SPC %z;
             if ( VectorLen( VectorSub(%pos1, %pos)) <= %blobsize)
               {
                if (!isObject($Dig_placedDirt[%pos1]))
                  $Dig_placedDirt[%pos1] = "MineOre" TAB %ore @ " 0 0";
               }
            }
         }
      }
   }
