// lava.cs
//
// Lava functions and processing for unlimited mining
//
$Dig_BlobSize=600;
$Dig_BlobSchedule=1000;

if (isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
  {
   if (!$RTB::RTBR_ServerControl_Hook)
     exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");

   RTB_registerPref("Lava Method","Unlimited Mining","$Dig_LavaMethod","list Blobs Blocks ","GameMode_UnlimitedMining","Blobs",0,0);
  }
else
  {
   $Dig_LavaMethod="Blobs";
  }
//$Dig_LavaMethod="Blocks";

// Return true if a lava should be placed at %pos
function MineLava::CheckPlace(%this, %pos, %random)
   {
    %low = %this.minPercent;
    %z = getWord(%pos, 2);


    if ( $Dig_LavaMethod $= "Blocks")
      {
       %low -= mfloor(mabs(%z / 200));
       //echo("lava block place method");
      }

    if ( (%random <= %this.maxPercent) && (%random >= %low ) )
      {
       if ( %this.depth == 0)
         {
          return true;
         }
       %z = getWord(%pos, 2);
       if ( %this.depth < 0)
         {
          if ( %z <= %this.depth)
            {
             return true;
            }
         }
       else
         if ( %z >= %this.depth)
           {
            return true;
           }
      }
    return false;
   }


// place a lava brick at %pos, and start a lava blob
function MineLava::placeAt(%this, %pos, %random)
   {
    %health=%this.value * 4;
    %lava = PlaceBrick(%pos, %health, %this.color, %this.colorFx, %this.ShapeFx, %this);

    CheckRadioActive(%lava);
    if ( $Dig_LavaMethod $= "Blobs" )
      {
       MakeLavaBlob(%pos, %lava);
      }

    return %lava;
   }

function MakeLavaBlob(%pos, %lava)
   {
    // place a new lava globe
    %rad = 2;
    %x = getWord(%pos, 0);
    %y = getWord(%pos, 1);
    %z = getWord(%pos, 2);
    %rad+= mFloor(mabs(%z) / 200);
    if ( %rad > 45)
      {
      %rad = 45;
      }
    if ( (%rad/2) != mFloor(%rad/2))
      {
       %rad++;
      }
    %rand = getRandom(1,6);
    switch ( %rand )
      {
       case 1 :
         %center= %x+%rad SPC %y SPC %z;
       case 2 :
         %center= %x-%rad SPC %y SPC %z;
       case 3 :
         %center= %x SPC %y+%rad SPC %z;
       case 4 :
         %center= %x SPC %y-%rad SPC %z;
       case 5 :
         %center= %x SPC %y SPC %z+%rad;
       case 6 :
         %center= %x SPC %y SPC %z-%rad;
      }

    //if ( %lava.radioactive)
    //  echo("start radioactive lava blob center: " @ %Center @ " rad: " @ %rad );
    //else
    //  echo("start lava blob center: " @ %Center @ " rad: " @ %rad );

    %z = getWord(%center, 2);
    %blob = new ScriptObject(LavaBlob) {
        center = %center;
        rad = %rad;
        type = "MineLava" TAB $Dig_Lava SPC %lava.radioactive SPC %lava.multiplier;
        dirtStart=1;
       };
    AddJob(%blob);
   }


function MineLava::getMineName(%this, %brick)
   {
    return MineOre::getMineName(%this, %brick);
   }

// mine a lava block
function MineLava::mined(%this, %client, %brick, %mode)
   {
    if ( $modeLava[%mode] ==1) // only if we are taking lava damage
      {
       if ( %client.heatsuit > 0)
         {
          if ( %brick.radioactive)
            {
             %client.heatsuit-=%brick.multiplier;
            }
          else
            %client.heatsuit--;

          if ( %client.heatsuit < 1)
            {
             messageClient(%client, '', "<color:88FF88>The Lava pocket burned off your heat suit<color:FF0000> -- you need to buy a new one!!");
             %client.heatsuit=0;
            }
          else
            {
             if ( %client.heatsuit < 20)
               messageClient(%client, '', "<color:5555FF>The Lava pocket burned a layer off your heat suit -- <color:FF0000>you have " @ %client.heatsuit @ " left");
            }
         }
       else
         {
          %client.player.kill();
          messageAll('', "<color:FFFFFF>"@ %client.getPlayerName() @" <color:00FF00>mined a lava pocket!");
          %client.heatsuit=0;
         }
      }
    %brick.health=0;
   }

// for some reason the $Dig_Lava global keeps getting deleted
function CheckDirt()
   {
    if ( isObject($Dig_Lava) )
      {
       return;
      }
    $Dig_Lava = new ScriptObject(MineLava)
        {
         name="Lava";
         value=1;
         color=0;
         minPercent=89.5;
         maxPercent=90;
         depth=-10;
         colorfx=3;
         blockdepth=10;
         blockSize=50;
        };
   }

// add a new lava blob to the processing queue
function AddJob(%job)
   {
    if ( !isObject($JobQueue) )
      {
       echo("Making new job Queue");
       $JobQueue = new ScriptObject()
         {
          entries = new SimSet() {};
          processing=0;
         };
      }
    $JobQueue.totalWork+=%job.rad;
    $JobQueue.entries.add(%job);
   }

// startup the job processor
function StartJobProcessor()
   {
    $JobWarning[4] = 5;
    $JobWarning[3] = 5;
    $JobWarning[2] = 5;
    $JobWarning[1] = 5;
    $JobWarningActive=false;
    $Dig_Data_DrillEnabled=true;
    $Dig_Data_BombSizeMax=35;
    $Dig_Data_BombSizeBuyLimit=20;
    PreCalculateLava(2);
    schedule(25000, 0, ProcessNextJob );
   }

// job processor.  Grab next job from the queue
function ProcessNextJob()
   {
    if ( $Dig_on != 1)
      {
       echo("Stopping job processor");
       return;
      }
    if ( $Dig_LavaMethod $= "Blocks")
      {
       return;
      }
    if ( $JobQueue.TotalWork < 1000)
      {
       // lava queue empty, reset warnings and undo all limits
       if ( $JobWarningActive)
         {
          $JobWarning[4] = 5;
          $JobWarning[3] = 5;
          $JobWarning[2] = 5;
          $JobWarning[1] = 5;
          $Dig_Data_DrillEnabled=true;
          $Dig_Data_BombSizeMax=35;
          $Dig_Data_BombSizeBuyLimit=20;
          messageAll('', "Server is back to normal, bombs & drills re-enabled");
          echo("bomb & drill restored");
          $JobWarningActive=false;
         }
      }

    if ( $JobQueue.entries.getCount() == 0 )
      {
       $JobQueue.TotalWork=0;
       schedule($Dig_BlobSchedule, 0, "ProcessNextJob");
       return;
      }

    if ( !isObject($CurrentJob) )
      {
       $CurrentJob = $JobQueue.entries.getObject(0);
       $JobQueue.entries.remove($CurrentJob);
       echo("processing job " @ $JobQueue.entries.getcount() SPC $CurrentJob.getName() SPC $CurrentJob.rad SPC $JobQueue.totalWork);
      }

    // job returns true when its done, false if it needs to be re-scheduled
    if ($CurrentJob.runJob() )
      {
       $JobQueue.TotalWork-=$CurrentJob.rad;
       $CurrentJob.delete();
      }

    if ( $JobQueue.TotalWork > 16000)
      {
       if ( $JobWarning[4] > 0)
         {
          messageAll('', "<color:FF0000>WARNING:<color:FFFFFF>The server is majorly overloaded -- DISABLING bombs/drills");
          cancelAllDrills();
          cancelAllBombs();
          $Dig_Data_BombSizeMax=0;
          $Dig_Data_BombSizeBuyLimit=0;
          $Dig_Data_DrillEnabled=false;
          $JobWarning[4]--;
          $JobWarning[3]=0;
          $JobWarning[2]=0;
          $JobWarning[1]=0;
          $JobWarningActive=true;
          AddLog(0, "overload Warn4", "Queue size " @ $JobQueue.entries.getCount() );
         }
      }
    else
    if ( $JobQueue.TotalWork > 12000)
      {
       if ( $JobWarning[3] > 0)
         {
          messageAll('', "<color:FF0000>WARNING:<color:FFFFFF>The server is seriously overloaded -- CANCELLING all bombs/drills");
          cancelAllDrills();
          cancelAllBombs();
          $JobWarning[3]--;
          $JobWarning[2]=0;
          $JobWarning[1]=0;
          $JobWarningActive=true;
          AddLog(0, "overload Warn3", "Queue size " @ $JobQueue.entries.getCount() );
         }
      }
    else
      if ( $JobQueue.TotalWork > 8000)
        {
         if ( $JobWarning[2] > 0)
           {
            messageAll('', "<color:FF0000>WARNING:<color:FFFFFF>The server is overloaded - bombs are limited to size 10");
            $Dig_Data_BombSizeMax=10;
            $Dig_Data_BombSizeBuyLimit=10;
            $JobWarning[2]--;
            $JobWarning[1]=0;
            $JobWarningActive=true;
            AddLog(0, "overload Warn2", "Queue size " @ $JobQueue.entries.getCount() );
           }
        }
      else
        if ( $JobQueue.TotalWork > 4000)
          {
           if ( $JobWarning[1] > 0)
             {
              messageAll('', "<color:FF0000>WARNING:<color:FFFFFF>The server is getting overloaded. Stop bombing/drilling so much");
              $JobWarning[1]--;
              $JobWarningActive=true;
              AddLog(0, "overload Warn1", "Queue size " @ $JobQueue.entries.getCount() );
             }
          }

    schedule($Dig_BlobSchedule, 0, "ProcessNextJob");
   }

// Job to replicate lavapoints
function LavaBlob::runJob(%this)
   {
    if ( $Dig_on != 1)
      {
       return true;
      }

    if ( !isObject($LavaBlobPoints[%this.rad] ))
      {
       echo("points for size: " @ %this.rad @ " not found");
       return true;
      }

    %size = $LavaBlobPoints[%this.rad].getCount();
    %points = $LavaBlobPoints[%this.rad];
    //echo("Replicate blob: " @ %this.center @ " size: "@ %this.rad @ " from: " @ %this.dirtStart @ " to " @ %size);
    for ( %a=1; %a < $Dig_BlobSize*2; %a++)
      {
       %pos = %points.getObject(%this.dirtStart);
       %newPos = vectorAdd(%pos.pos, %this.center);
       %spot = $Dig_PlacedDirt[%newPos];
       if ( getSubstr(%spot, 0, 8) $= "MineLava")
         {
          //echo("Lava Replicate Stopped " @ %this.center @ " size: " @ %this.rad);
          $LavaBlobPoints[%this.rad].uses++;
          return true;
         }
       if ( %spot $= "")
         {
          $Dig_placedDirt[%newPos] = %this.type;
         }
       if ( %spot.type.name $= "Dirt")
         {
          %data = getField(%this.type, 1);
          %spot.type = $Dig_Lava;
          %spot.setColor($Dig_Lava.color);
          %spot.setColorFx($Dig_Lava.colorFx);

          %spot.radioactive=getword(%data, 1);
          %spot.multiplier=getWord(%data,2);
         }

       %this.dirtStart++;
       if ( %this.dirtStart >= %size)
         {
          //echo("Lava Replicate Done " @ %this.center @ " size: " @ %this.rad);
          $LavaBlobPoints[%this.rad].uses++;
          return true;
         }
      }

    // job is not done yet
    return false;
   }

//Job to Create lavapoints
function LavaPoints::runJob(%this)
   {
    if ( $Dig_on != 1)
      {
       return true;
      }

    //echo("Generate Points for size: " @ %this.size @ " cur: " @ %this.currX SPC %this.CurrY SPC %this.currZ);
    if ( !isObject(%this.points) )
      {
       %this.points = new SimSet() {};
      }

    for ( %a=0; %a < $Dig_BlobSize*3; %a++)
      {
       %pos = %this.CurrX SPC %this.CurrY SPC %this.CurrZ;

       if ( VectorLen( %pos) <= %this.size)
         {
          %obj = new ScriptObject() {
            pos = %pos;
          };
          %this.points.add(%obj);
         }

       %this.CurrX+=2;
       if ( %this.CurrX > %this.EndX)
         {
          %this.CurrX = - %this.size;
          %this.CurrY+=2;
          if ( %this.CurrY > %this.EndY)
            {
             %this.CurrY = - %this.size;
             %this.currZ+=2;
            }
         }

       if ( %this.CurrZ > %this.EndZ)
         {
          break;
         }
      }

    if ( %this.CurrZ > %this.EndZ)
      {
       echo("Created LavaBlobPoints for size "@  %this.size);
       $LavaBlobPoints[%this.size] = %this.points;
       $LavaBlobPoints[%this.size].uses=0;
       %blob.points = 0;
       return true;
      }

    // job is not done yet
    return false;
   }

// Pre-calculate the lava blob points
function PrecalculateLava(%size)
   {
    if ( $Dig_on != 1)
      {
       return;
      }
    if ( $Dig_LavaMethod $= "Blocks")
      {
       return;
      }

    if ( !isObject($JobQueue) )
      {
       echo("Making new Job Queue");
       $JobQueue = new ScriptObject()
         {
          entries = new SimSet() {};
         };
      }
    if ( ($JobQueue.entries.getCount() < 10) || !$Dig_Data_DrillEnabled )
      {
       for ( %a=0; %a < 15; %a+=2)
         {
          %rad = %a+%size;

          if ( %rad > 47)
            {
             // all blob points submitted
             return;
            }

          %job = new ScriptObject(LavaPoints)
            {
             size = %rad;
             currX = -%rad;
             endX  =  %rad;
             currY = -%rad;
             endY  =  %rad;
             currZ = -%rad;
             endZ  =  %rad;
            };
          echo("Add job for size: " @ %job.size);
          AddJob(%job);
         }
       %rad = %a+%size;
      }
    else
      echo("Job queue size: " @ $JobQueue.entries.getCount() @ " try again in 1min");

    // check again in 1min
    schedule(1000*60, 0, "PrecalculateLava", %rad);
   }

function BlobUseReport()
   {
    AddLog(0, "Blob use", "start of report", 1);
    for ( %a=0; %a < 50; %a++)
      {
       %obj = $LavaBlobPoints[%a];
       if ( isObject(%obj ) )
         {
          if (%obj.uses > 0)
            {
             AddLog(0, "blob use", "Size: " @ %a @ " used: " @ %obj.uses , 1);
            }
         }
      }
   }
